--
-- Beleuchtung v3
-- Specialization for additional lights
-- Spezialisierung fr Zusatzbeleuchtung
-- @author  Sven777b
-- 
-- frei verwendbar - keine erlaubnis ntig  |  free for use - no permission needed.
-- Modifikationen erst nach Rcksprache!    |  modifications only with my permission.
--
-- Hinweis: das kopieren von Sourcecode ist strafbar nach UrhG 2.1

Liftaxis = {};

function Liftaxis.prerequisitesPresent(specializations)
    return true;
end;

function Liftaxis:load(xmlFile)
	local lai = getXMLInt(xmlFile, "vehicle.liftaxis#compJoint");
	if(self.componentJoints[lai] ~= nil) then
		self.liftAxis = {};
		self.liftAxis.compJoint = self.componentJoints[lai];

    local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.liftaxis#upperPos"));
    self.liftAxis.PosUp = {};
    self.liftAxis.PosUp[1] = Utils.getNoNil(x, 0);
    self.liftAxis.PosUp[2] = Utils.getNoNil(y, 0.5);
    self.liftAxis.PosUp[3] = Utils.getNoNil(z, 0);

    local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.liftaxis#lowerPos"));
    self.liftAxis.PosDn = {};
    self.liftAxis.PosDn[1] = Utils.getNoNil(x, 0);
    self.liftAxis.PosDn[2] = Utils.getNoNil(y, 0);
    self.liftAxis.PosDn[3] = Utils.getNoNil(z, 0);
    
    self.liftAxis.mvtime = Utils.getNoNil(getXMLInt(xmlFile, "vehicle.liftaxis#movetime"),5) * 1000;

		self.liftAxis.lifted = true;
		self.liftAxis.lift = true;
	end;
end;

function Liftaxis:delete()
end;

function Liftaxis:mouseEvent(posX, posY, isDown, isUp, button)
end;

function Liftaxis:keyEvent(unicode, sym, modifier, isDown)
end;

function Liftaxis:update(dt)
	if self.liftAxis then
    if self:getIsActiveForInput() then
        if InputBinding.hasEvent(InputBinding.FLIFTACHSE) then
            self.liftAxis.lift = not self.liftAxis.lift;
        end;
    end;

		if self:getIsActive() then
			if self.liftAxis.lift ~= self.liftAxis.lifted then
				local x, y, z = getTranslation(self.liftAxis.compJoint.jointNode);
				local ctrans = {x,y,z};
				local ntrans = Utils.getMovedLimitedValues(ctrans, self.liftAxis.PosUp, self.liftAxis.PosDn, 3, self.liftAxis.mvtime, dt, not self.liftAxis.lift);
				setJointFrame(self.liftAxis.compJoint.jointIndex, 0, self.liftAxis.compJoint.jointNode);
				setTranslation(self.liftAxis.compJoint.jointNode,unpack(ntrans));
				local finalpos = true;
        for i=1, 3 do
            if math.abs(ntrans[i] - ctrans[i]) > 0.001 then
                finalpos = false;
            end;
        end;
        if finalpos then
        	self.liftAxis.lifted = self.liftAxis.lift;
        end;
      end;
    end;
  end;
end;

function Liftaxis:draw()
	if self:getIsActiveForInput() and self.liftAxis then
		g_currentMission:addHelpButtonText(g_i18n:getText("FLIFTACHSE"), InputBinding.FLIFTACHSE);
	end;
end;

function Liftaxis:onDetach()
end;

function Liftaxis:onAttach()
end;
